"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createOssRepo = void 0;
const index_1 = require("../index");
const ipfs_repo_1 = require("ipfs-repo");
const blockstore_datastore_adapter_1 = require("blockstore-datastore-adapter");
const sharding_1 = require("datastore-core/sharding");
const shard_1 = require("datastore-core/shard");
const raw = __importStar(require("multiformats/codecs/raw"));
const json = __importStar(require("multiformats/codecs/json"));
const dagPb = __importStar(require("@ipld/dag-pb"));
const dagCbor = __importStar(require("@ipld/dag-cbor"));
/**
 * A convenience method for creating an oss backed IPFS repo
 */
const createOssRepo = (path, oss, repoLock) => {
    const storeConfig = {
        oss,
        createIfMissing: true,
    };
    /**
     * These are the codecs we want to support, you may wish to add others
     */
    const codecs = {
        [raw.code]: raw,
        [raw.name]: raw,
        [json.code]: json,
        [json.name]: json,
        [dagPb.code]: dagPb,
        [dagPb.name]: dagPb,
        [dagCbor.code]: dagCbor,
        [dagCbor.name]: dagCbor,
    };
    const loadCodecFunc = async (codeOrName) => {
        if (codecs[codeOrName]) {
            return codecs[codeOrName];
        }
        throw new Error(`Unsupported codec ${codeOrName}`);
    };
    return (0, ipfs_repo_1.createRepo)(path, loadCodecFunc, {
        root: new sharding_1.ShardingDatastore(new index_1.OssDatastore(path, storeConfig), new shard_1.NextToLast(2)),
        blocks: new blockstore_datastore_adapter_1.BlockstoreDatastoreAdapter(new sharding_1.ShardingDatastore(new index_1.OssDatastore(`${path}blocks`, storeConfig), new shard_1.NextToLast(2))),
        datastore: new sharding_1.ShardingDatastore(new index_1.OssDatastore(`${path}datastore`, storeConfig), new shard_1.NextToLast(2)),
        keys: new sharding_1.ShardingDatastore(new index_1.OssDatastore(`${path}keys`, storeConfig), new shard_1.NextToLast(2)),
        pins: new sharding_1.ShardingDatastore(new index_1.OssDatastore(`${path}pins`, storeConfig), new shard_1.NextToLast(2)),
    }, {
        repoLock,
    });
};
exports.createOssRepo = createOssRepo;
